# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "IProcessorPlatform",
    "IHasProcessorPlatform",
    ]

from zope.interface import (
    Attribute,
    Interface,
    )
from zope.schema import TextLine

from lazr.restful.declarations import exported


class IProcessorPlatform(Interface):

    name = Attribute("Name for this processor platform.")


class IHasProcessorPlatform(Interface):
    """An entity which has a processor platform."""

    platform = Attribute("Processor platform")

    platform_name = exported(
        TextLine(
            title=u"Processor platform name",
            required=True,
            readonly=True))
