# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "Functor",
    ]


class Functor:

    def __init__(self, function, *args, **kwargs):
        assert callable(function), "function should be a callable obj"
        self.function = function
        self.args = args
        self.kwargs = kwargs

    def __call__(self, *args, **kwargs):
        """Call the function."""
        _kwargs = self.kwargs.copy()
        _kwargs.update(kwargs)
        return apply(self.function, self.args + args, _kwargs)
