# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = []

from datetime import (
    datetime,
    timedelta,
    )
from pytz import utc

from unittest import defaultTestLoader

from zope.interface.verify import verifyObject

from lpresults.scripts.interfaces.activity import IActivity
from lpresults.scripts.models.activity import Activity
from lpresults.scripts.testing.cases import TestCaseWithFactory
from lpresults.scripts.testing.layers import DatabaseLayer


class TestActivity(TestCaseWithFactory):

    layer = DatabaseLayer

    def test_implements(self):
        """Activity should implement IActivity."""
        name = self.factory.getUniqueString(u"name")
        hostname = self.factory.getUniqueString(u"hostname")
        date_started = datetime(2010, 1, 1, tzinfo=utc)
        date_completed = date_started + timedelta(days=1)
        activity = Activity(name, hostname, date_started, date_completed)
        verifyObject(IActivity, activity)


def test_suite():
    return defaultTestLoader.loadTestsFromName(__name__)
