# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "CputableParser",
    ]

import re


CPUTABLE_RE = re.compile(
    r"^(?!\#)(?P<debian_name>\S+)"
    r"\s+(?P<gnu_name>\S+)"
    r"\s+(?P<regex>\S+)"
    r"\s+(?P<bits>\d+)"
    r"\s+(?P<endianness>big|little)")


class CputableParser:
    """Parser for the /usr/share/dpkg/cputable file."""

    def __init__(self, stream):
        self.stream = stream

    def run(self, result):
        for line in self.stream.readlines():
            match = CPUTABLE_RE.match(line)
            if match:
                cpu = match.groupdict()
                cpu["bits"] = int(cpu["bits"])
                result.addCpu(cpu)
