# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "DeferredParser",
    ]


class DeferredParser:
    """Parser for deferred dispatching of events."""

    def __init__(self, dispatcher, event_type=None):
        self.dispatcher = dispatcher
        self.event_type = event_type

    def run(self, result):
        if self.event_type is not None:
            self.dispatcher.publishEvent(self.event_type, result)
